/*
 * $Id: config.h,v 1.4 2005/08/21 16:56:42 amaia Exp $
 */
#ifndef __CONFIG_H
#define __CONFIG_H

#include "pup_stl.h"

class config {

public:
	config(int argc, char** argv);
	config();
	void init(int argc, char** argv);
	int read();

	void pup(PUP::er &p);

	u64 get_N() { return N_; }
	u64 get_M() { return M_; }
	u64 get_VEZ() { return VEZ_; }
	u64 get_Ttrans() { return Ttrans_; }
	u64 get_T() { return T_; }
	ldouble get_tau() { return tau_; }
	ldouble get_U() { return U_; }
	ldouble get_S2() { return S2_; }
	ldouble get_mtarget() { return mtarget_; }
	ldouble get_Emax() { return Emax_; }
	ldouble get_sigma_gauss_q() { return sigma_gauss_q_; }
	ldouble get_sigma_gauss_p() { return sigma_gauss_p_; }
	int get_debug_level() { return debug_level_; }
	std::string get_out_dir() { return out_dir_; }
	std::string get_inp_dir() { return inp_dir_; }


private:
	u64 N_;
	u64 M_;
	ldouble tau_;
	ldouble U_;
	u64 VEZ_;
	ldouble S2_;
	ldouble mtarget_;
	u64 Ttrans_;
	u64 T_;
	ldouble Emax_;
	ldouble sigma_gauss_q_;
	ldouble sigma_gauss_p_;
	
	std::string cfg_file_;
	std::string out_dir_;
	std::string inp_dir_;

	int debug_level_;
	
	int argc_;
	char** argv_;

};

#endif
